QGIS Application - Bug report #16242
QGIS 2.18.4 saves always with absolute paths
2017-02-27 01:31 PM - Giovanni Manghi

Status: Closed

Priority: High

Assignee: Alessandro Pasotti

Category: Project Loading/Saving

Affected QGIS version:2.18.4 Regression?: Yes

Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 24152
Description

Regardless of what chosen in project properties.

Master seems ok.

Related issues:
Duplicated by QGIS Application - Bug report # 16550: Virtual layer path is no... Closed 2017-05-15

Associated revisions

Revision 913527b4 - 2017-05-12 01:59 PM - Alessandro Pasotti

[bugfix] Fixes #16242 saves always with absolute paths

History

#1 - 2017-02-27 01:32 PM - Giovanni Manghi
- Affected QGIS version changed from 2.18.3t0 2.18.4

#2 - 2017-02-27 11:20 PM - Richard Duivenvoorde

Hi, I just created a fresh project with current 2.18.4 yesterday, and sent it to a client with the shape files next to it, (and was afraid that | hit this bug...).

So | just checked the .qgs file, but | see: <datasources./mylayer.shp</datasource> in the xml.

It was a fresh project, and | have default 'relative paths'...

| have a yesterday fresh compiled 2.18.4, which in the checkbox says:
QGIS code revision 2ccdac770b

So is there a certain thing you did? To have this?

#3 - 2017-02-27 11:23 PM - Giovanni Manghi

Richard Duivenvoorde wrote:

Hi, I just created a fresh project with current 2.18.4 yesterday, and sent it to a client with the shape files next to it, (and was afraid that I hit this
bug...).

So | just checked the .qgs file, but | see: <datasource>./mylayer.shp</datasource> in the xml.
It was a fresh project, and | have default 'relative paths'...

| have a yesterday fresh compiled 2.18.4, which in the checkbox says:
QGIS code revision 2ccdac770b

So is there a certain thing you did? To have this?

Hi Richard,

yesterday when | first checked and replied in the dev ML | wasn't able to replicate.

The tested again and again in Windows with both 2.18.4 and master and with first | regularly only got absolute paths regardless the project configs. This

was never the case on master.

#4 - 2017-04-10 01:42 AM - Christian S

We too have problems with relative paths becoming absolute paths.

Some background:

Several people access a QGIS-project with relative paths for some datasources.

All of them use linux (Ubuntu 14.04 and 16.04) but use different methods of mounting the project directory from a samba share so the basepath is different

on each computer.

Some use the gvfs mechanism from Ubuntu and others use mount with autofs. The used QGIS-Versions are 2.18.4 and 2.18.5.

We observe that sometimes relative paths become absolute paths in this scenario but unfortunately we have not found a reproducable test case yet.
This [1] Question with answer may be related, too. The solution offered there seems to work for our broken QGIS-projects.

[1]: http://gis.stackexchange.com/questions/210992/relative-path-not-working-in-qgis

#5 - 2017-04-11 04:15 AM - Alexander Bruy
- Status changed from Open to Feedback

Seems works fine in 2.18.6

#6 - 2017-04-11 04:41 AM - Giovanni Manghi

Alexander Bruy wrote:

Seems works fine in 2.18.6

Alex this is tricky, not easy to replicate. | have seen this lately too, also on 2.18.5, possibly .6.

Try open a project with a few file based layers, and check the .qgs file if it has absolute paths.

#7 - 2017-04-27 05:42 AM - Paul Henshaw

Hi all,
http://gis.stackexchange.com/questions/210992/relative-path-not-working-in-qgis

| am able to reproduce the problem using the "Save As" feature, as described in

https://gis.stackexchange.com/questions/210992/relative-path-not-working-in-ggis

_ It seems that the the relative path for a shp file will be changed to an absolute path after the project file is "saved as" a new project file. (see images

below).

[]

After saving the current QGIS project file as a new file, you MUST press the SAVE button so as to confirm that the relative path is registered in the

project file. Otherwise, the absolute path will be used._

I am currently using QGIS 2.18.7 (64bit Windows 10) but was also able to reproduce using 2.18.3.

#8 - 2017-04-27 05:47 AM - Giovanni Manghi

- Status changed from Feedback to Open

#9 - 2017-04-27 05:54 AM - Paul Henshaw

Paul Henshaw wrote:

I am currently using QGIS 2.18.7 (64bit Windows 10) but was also able to reproduce using 2.18.3.

My colleague confirms that the behaviour is the same using 2.18.7 on Ubuntu 16.04 LTS (64bit).

#10 - 2017-04-30 05:08 PM - Giovanni Manghi

- Regression? set to Yes

#11 - 2017-04-30 05:08 PM - Giovanni Manghi
- Priority changed from Severe/Regression to High

#12 - 2017-05-01 01:10 AM - Giovanni Manghi

- Easy fix? set to No

#13 - 2017-05-12 11:16 AM - Alessandro Pasotti
- Description updated

- Assignee set to Alessandro Pasotti

#14 - 2017-05-12 02:00 PM - Anonymous

- Status changed from Open to Closed
- % Done changed from 0 to 100

Applied in changeset commit:qgis|913527b4c95dce5f0bc3c6def52c29f6341cec39.

#15 - 2017-05-12 02:01 PM - Giovanni Manghi
- Resolution set to fixed/implemented

#16 - 2017-05-12 03:08 PM - Alessandro Pasotti
https://gis.stackexchange.com/questions/210992/relative-path-not-working-in-qgis

- Resolution deleted (fixed/implemented)

Explanation: when saving the project with a new name and the destination file did not exist, the path of the destintion file was blank, breaking the algorithm
that build the relative path.
For this reason the bug could not be reproduced when saving (overwriting) an existing project file.

#17 - 2017-05-12 03:08 PM - Alessandro Pasotti

- Resolution set to fixed/implemented

#18 - 2017-05-19 09:01 AM - Jiirgen Fischer
- Duplicated by Bug report #16550: Virtual layer path is not relative added

#19 - 2017-09-07 02:35 PM - Patrick Dunford

This issue can be produced in master revision commit:313ec55640adf3696d8b7554cc6d9b7fc319c2df

Do | assume if | pull the zip file from https://github.com/qgis/QGIS/tree/913527b4c95dce5f0bc3c6def52c29f634 1cec39 that | will get the fix to this

problem.

#20 - 2017-09-07 03:36 PM - Alessandro Pasotti

yes

#21 - 2017-09-07 06:36 PM - Patrick Dunford

That one is 2.18, | need the version of master that has that fix incorporated.

#22 - 2017-09-07 08:24 PM - Giovanni Manghi

Patrick Dunford wrote:

This issue can be produced in master revision commit:313ec55640adf3696d8b7554cc6d9b7fc319c2df

if is not fixed in master then a new (regression) ticket must be opened. Thanks.

#23 - 2018-01-09 11:58 AM - Patrick Dunford

See also #17824
https://github.com/qgis/QGIS/tree/913527b4c95dce5f0bc3c6def52c29f6341cec39

